/*
 * JBoss, Home of Professional Open Source
 * Copyright 2005, JBoss Inc., and individual contributors as indicated
 * by the @authors tag. See the copyright.txt in the distribution for a
 * full listing of individual contributors.
 *
 * This is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; either version 2.1 of
 * the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software; if not, write to the Free
 * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
 */
/*package org.jboss.wiki;

import java.util.Date;

import javax.jms.Message;
import javax.jms.MessageListener;
import javax.jms.ObjectMessage;
import javax.mail.Address;
import javax.mail.Session;
import javax.mail.Transport;
import javax.mail.Message.RecipientType;
import javax.mail.internet.InternetAddress;
import javax.mail.internet.MimeMessage;
import javax.naming.InitialContext;
import javax.rmi.PortableRemoteObject;
import javax.ejb.MessageDriven;

import org.jboss.logging.Logger;
import org.jboss.wiki.management.NotificationMsg;

public @MessageDriven(activateConfig = {
		@javax.ejb.ActivationConfigProperty(propertyName = "destinationType", propertyValue = "javax.jms.Queue"),
		@javax.ejb.ActivationConfigProperty(propertyName = "destination", propertyValue = "queue/wikiNotifications") })
class MailNotificationBean implements MessageListener {

	private Logger log = Logger.getLogger(this.getClass());

	public void onMessage(Message msg) {

		log.debug("Mail");
		
		try {

			ObjectMessage omsg = (ObjectMessage) msg;
			Session session = null;

			try {
				session = (Session) PortableRemoteObject
						.narrow(new InitialContext().lookup("java:Mail"),
								Session.class);
				try {
					if (omsg.getObject() instanceof NotificationMsg) {
						NotificationMsg notifications = (NotificationMsg) omsg
								.getObject();
						
						log.debug("Got email notification msg");

						for (String email : notifications.getEmails()) {
							log.debug("MDB for: " + email);

							StringBuffer buffer = null;
							Address[] to = null;
							MimeMessage m = new MimeMessage(session);

							if (email != null) {
								m.setFrom(new InternetAddress(notifications.getFromEmail()));
								to = new InternetAddress[] { new InternetAddress(
										email) };
								m.setRecipients(RecipientType.TO, to);
								m.setSubject("[JBossWiki] Page change notification: " + notifications.getPageName());

								m.setSentDate(new Date());
								buffer = new StringBuffer();
								
								buffer.append("This message is generated automaticcaly. Please do not reply. To remove yourself from the watch list please go to ").append(notifications.getPageLink()).append("<br />\n");
								buffer.append(notifications.getPageContent());

								m.setContent(buffer.toString(), "text/html; charset=\"UTF-8\"");
								Transport.send(m);
							}
						}
					}
				} catch (javax.mail.MessagingException e) {
					log.error(e);
				}
			} catch (javax.naming.NamingException e) {
				log.error(e);
			}
		} catch (Exception e) {
			log.error(e);
		}

	}
}*/
